program FbSvc;

uses
	Windows,
	Messages,
	WinSvc,
        //SysUtils, // Uncomment it if you dont have Kol Lib
        Kol;        // Get it at http://xcl.cjb.net/

{$R *.RES}

function GetPath: String;
var
        Key: HKey;
        DataType: Integer;
        BuffSize: Integer;
        Buffer: String;
begin
	Result := '';
        If RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'Software\Borland\InterBase\CurrentVersion', 0, KEY_READ, Key) = ERROR_SUCCESS Then
        Begin
             SetLength(Buffer, 255);
             ZeroMemory(@Buffer[1], 255);
             DataType := REG_SZ;
             BuffSize := 255;
             If RegQueryValueEx(Key, 'RootDirectory', nil, @DataType, @Buffer[1], @BuffSize) = ERROR_SUCCESS Then
                Result := Trim(Copy(Buffer, 1, BuffSize));
             RegCloseKey( Key );
        End;
end;

function IsNT: Boolean;
var
	OSVersion: TOSVersionInfo;
begin
	Result := False;
	OSVersion.dwOSVersionInfoSize := SizeOf(OSVersion);
	if (GetVersionEx(OSVersion)) then
            Result := (OSVersion.dwPlatformID = VER_PLATFORM_WIN32_NT);
end;

function StopServer: Boolean;
var
	lHWND: HWND;
	sFirebirdPath: String;
begin
	Result := False;
	if IsNT then
	begin
		sFirebirdPath := GetPath;
		if (sFirebirdPath <> '') then
		begin
			sFirebirdPath := sFirebirdPath + 'bin\instsvc.exe stop';
			Result := (WinExec(PChar(sFirebirdPath), SW_HIDE) > 31);
		end;
	end
	else
	begin
		lHWND := FindWindow('IB_Server', 'InterBase Server');
                Result := PostMessage(lHWND, WM_CLOSE, 0, 0);
	end;
end;

function InstallAndStartGuardian: Boolean;
var
	hanManager, hanGuardian: SC_Handle;
	ss: TServiceStatus;
	dwChkP: DWord;
	sTemp: PCHar;
	bResultInstall, bResultStart: Boolean;
	sFirebirdPath, sExecName: String;
        Key: HKey;
begin
	Result := False;
	if IsNT then
	begin
		hanManager := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
		try
			if (hanManager <> 0) then
			begin
				hanGuardian := CreateService(hanManager, 'InterBaseGuardian', 'InterBase Guardian', SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS or SERVICE_INTERACTIVE_PROCESS,
					SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, PChar(GetPath + 'bin\ibguard.exe -s'), nil, nil, nil, nil, nil);
				try
					hanGuardian := OpenService(hanManager, 'InterBaseGuardian', SERVICE_START or SERVICE_QUERY_STATUS);
					sTemp := nil;
					if (hanGuardian <> 0) then
					begin
						if (StartService(hanGuardian, 0, sTemp) = True) then
							if (QueryServiceStatus(hanGuardian, ss) = True) then
								while (SERVICE_RUNNING <> ss.dwCurrentState) do
								begin
									dwChkP := ss.dwCheckPoint;
									Sleep(ss.dwWaitHint);
									if not (QueryServiceStatus(hanGuardian, ss) = True) then
										Break;
									if (ss.dwCheckPoint < dwChkP) then
										Break;
								end;
						Result := (SERVICE_RUNNING = ss.dwCurrentState);
					end;
				finally
					CloseServiceHandle(hanGuardian);
				end;
			end;
		finally
			CloseServiceHandle(hanManager);
		end;
	end
	else
	begin
		bResultInstall := False;
		bResultStart := False;
		sFirebirdPath := GetPath;
                sExecName := sFirebirdPath + 'bin\ibguard.exe -a';
                If RegCreateKeyEx(HKEY_LOCAL_MACHINE,'SOFTWARE\Microsoft\Windows\CurrentVersion\Run',
                          0, 'REG_SZ', REG_OPTION_NON_VOLATILE, KEY_WRITE, nil, Key, nil ) = ERROR_SUCCESS Then
                Begin
                     bResultInstall := (RegSetValueEx(Key, 'Firebird Guardian', 0, REG_SZ, @sExecName[1], Length(sExecName)) = ERROR_SUCCESS);
                     RegCloseKey( Key );
                End;
		if (sFirebirdPath <> '') then
		begin
			sExecName := sFirebirdPath + 'bin\ibguard.exe';
			bResultStart := (WinExec(PChar(sExecName), SW_SHOW) > 31);
		end;
		Result := bResultInstall and bResultStart;
	end;
end;

function StopAndDeinstallGuardian: Boolean;
var
	hanManager, hanGuardian: SC_Handle;
	lHWND: HWND;
	ss: TServiceStatus;
	dwChkP:DWord;
	bResultStop, bResultDeinstall: Boolean;
        Key: HKey;
begin
	Result := False;
	if IsNT then
	begin
		hanManager := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
		try
			if (hanManager <> 0) then
			begin
				hanGuardian := OpenService(hanManager, 'InterBaseGuardian', SC_MANAGER_ALL_ACCESS);
				try
					if (hanGuardian <> 0) then
					begin
						if (ControlService(hanGuardian, SERVICE_CONTROL_STOP, ss) = True) then
							if (QueryServiceStatus(hanGuardian, ss) = True) then
								while (SERVICE_STOPPED <> ss.dwCurrentState) do
								begin
									dwChkP := ss.dwCheckPoint;
									Sleep(ss.dwWaitHint);
									if not (QueryServiceStatus(hanGuardian, ss) = True) then
										Break;
									if (ss.dwCheckPoint < dwChkP) then
										Break;
								end;
							bResultStop := (SERVICE_STOPPED = ss.dwCurrentState);
							bResultDeinstall := DeleteService(hanGuardian);
							if ((bResultStop = True) and (bResultDeinstall = True)) then
								Result := True;
					end;
				finally
					CloseServiceHandle(hanGuardian);
				end;
			end;
		finally
			CloseServiceHandle(hanManager);
		end;
	end
	else
	begin
	     bResultDeinstall := False;
	     lHWND := FindWindow('IB_Guard', 'InterBase Guardian');
             bResultStop := PostMessage(lHWND, WM_CLOSE, 0, 0);
             If RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'Software\Microsoft\Windows\CurrentVersion\Run', 0, KEY_WRITE, Key) = ERROR_SUCCESS Then
             Begin
	          bResultDeinstall := (RegDeleteValue(Key, 'Firebird Guardian') = ERROR_SUCCESS);
                  RegCloseKey( Key );
             End;
             Result := bResultStop and bResultDeinstall;
	end;
end;

var
	I: Integer;
begin
	If ParamCount > 0 Then
	for I := 1 to ParamCount do
	begin
		if (UpperCase(ParamStr(I)) = '/INSTALL_GUARDIAN') then
			InstallAndStartGuardian;
		if (UpperCase(ParamStr(I)) = '/DEINSTALL_GUARDIAN') then
			StopAndDeinstallGuardian;
		if (UpperCase(ParamStr(I)) = '/STOP_SERVER') then
			StopServer;
	end
        Else
 	    MessageBox(0,'No switches specified!'#13#13'Usage:  FbSvc   [/Install_Guardian]  [/Deinstall_Guardian]  [/Stop_Server]  ', 'FireBird Service', MB_OK + MB_ICONEXCLAMATION);
end.
